#pragma once

#define DIRECTINPUT_VERSION		DIRECTINPUT_HEADER_VERSION
#include <dinput.h>
#include <map>
#include <vector>

#pragma comment(lib,"dxguid.lib")
#pragma comment(lib,"dinput8.lib")


struct fkut_InputInfo {
	static const int BUTTON_NUM = 32;
	// Ă{^trueAĂȂfalse
	bool	button[BUTTON_NUM];
	// XeBbNƂ㉺E̓͏
	bool	up;
	bool	down;
	bool	left;
	bool	right;
	// x[0],y[0]XeBbNAx[1],y[1]EXeBbÑAiOl
	short	x[2];
	short	y[2];
	// -1POV͏ԁA^0ƂAv4500l
	int		pov;
};

#include <stdio.h>

class fkut_Input {
private:
	static const int DIMGR_BUFFER_SIZE = 256;
	static const int INPUT_DEVICE_NUM = 16;
	static const int MOUSE_BUTTON_MAX = 8;
	static const int KEY_NUM = 256;

	int		**buttonSwap;
	DWORD	axisMap[8], povMap[8], keyMap[fkut_InputInfo::BUTTON_NUM];

    // Rs[RXgN^͖
    fkut_Input(const fkut_Input& other);
    // Zq
    fkut_Input& operator=(const fkut_Input& other);

	//L[{[h̃o[ϐ
	bool m_Key[KEY_NUM];

	//}EX̃o[ϐ
	POINT	m_MouseWorldPos;	//}EX̐΍W
	int		m_MouseWheel;
	POINT	m_MouseLocalPos;	//}EX̃[JW
	bool	m_Button[MOUSE_BUTTON_MAX];
	bool	m_LastButton[MOUSE_BUTTON_MAX];

	//Joỹo[ϐ
	DWORD					m_JoyCount;
	DWORD					m_JoyMaxCount;
	fkut_InputInfo*			m_JoyButton;
	int						m_AllowX;		//XW̗V	0`1000̒lłBႢقǕq
	int						m_AllowY;		//YW̗V	0`1000̒lłBႢقǕq
	int						m_AllowMin, m_AllowMax;	// AiOXeBbN̒lŗLƂ͈͂w肵܂

	//foCX֘Ão[ϐ
	HWND					m_hwnd;
	LPDIRECTINPUT8			m_Input;
	LPDIRECTINPUTDEVICE8	m_KeyBoardDevice;
	LPDIRECTINPUTDEVICE8	m_MouseDevice;
	LPDIRECTINPUTDEVICE8	m_JoyStciDevice[INPUT_DEVICE_NUM];
	DIDEVCAPS				m_DevCaps;
	DIDEVICEOBJECTDATA		m_DeviceObject[DIMGR_BUFFER_SIZE];  // Receives buffered data 

	//=====================
	//Update֘A
	//=====================
	HRESULT UpdateJoy(void);
	HRESULT UpdateMouse(void);
	HRESULT UpdateKey(void);
	
	//===========================
	//JoỹR[obN֐
	//===========================
	static BOOL CALLBACK EnumSizesCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi, LPVOID lpvRef);
	static BOOL CALLBACK EnumJoysticksCallback(const DIDEVICEINSTANCE* lpddi, LPVOID lpContext);

	short AdjustParam(short);

public:
	//==============================
	//	RXgN^EfXgN^
	//==============================
	fkut_Input(void);
	~fkut_Input(void);

	//==============================
	//	}EXEL[{[h擾֘A
	//==============================
	/*
		ւ͎͂ŎgȂgĂłA
		̃o[Wł͒JȃT|[g͂Ă܂B
		ɃQ[pbhƃL[{[hɃNɂĂ͉̖̕߂֗Ȃ̂ŁA
		̕g悤ɂĂB
	*/

	// }EX֘A
	POINT&	GetMouseLocalPos(void);
	POINT&	GetMouseWorldPos(void);
	bool	GetMouseButton(DWORD keycode);
	bool	GetLastMouseButton(DWORD keycode);
	int		GetMouseWheel(void);

	// L[֘A
	bool	GetKey(const DWORD keycode);

	//==============================
	//	{
	//==============================

	//! 
	/*
		ŏɕK1ĂłB^C~OƃVrAŁA
		uFl_Window̕ϐɑ΂show()Ă񂾌vɌĂԕKv܂B
		ɂ(fl_display, fl_xid(&Fl_Window̕ϐ))ƋLq܂B
		fl_xid()Ƃ֐gɂ#include <Fl/x.h>KvɂȂ܂B
		LqƂăTvQƂĂB
		ƏςނS_OKƂԒlԂ܂B
	*/
	HRESULT init(HINSTANCE hinst, HWND hwnd);
	
	//! Еt
	/*
		vOOɌĂт܂BYĂfXgN^ŌĂяo܂A
		ŌĂłSmłB
	*/
	HRESULT uninit(void);

	//! XV
	/*
		t[Ƃɓ͏ԂXV܂B`揈̌ɂłĂłB
		Ă΂ȂƁAJԂĂ͂ɔĂ܂B
	*/
	HRESULT update(void);

	//==============================
	//	WCXeBbN֘A
	//==============================

	//!	WCXeBbN{擾
	/*
		init()_ŉ{̃WCXeBbNF擾܂B
		init()Ă甲Ă֒mł܂B
	*/
	inline DWORD	getJoyCount(void);

	//!	WCXeBbN̏擾
	/*
		WCXeBbN̏Ԃ̂܂܂擾܂B
		fkut_InputInfo^̃|C^ϐpӂAŎ󂯎ĂB
		{^̓ւ͔fꂽ񂪕Ԃ܂AL[{[hł֑͍̑l܂B
		L[{[hƏ{ꍇgetInputStatus()߂łB
		ɂ͎擾WCXeBbNIDԍw肵܂B1{ڂ0ɂȂ܂B
		ȃWCXeBbN̔ԍw肳ꂽꍇNULLԂ܂B
	*/
	fkut_InputInfo*	getJoyStick(DWORD inJoyIndex);

	//!	XeBbN̂lݒ
	/*
		XeBbN͏\L[Ɏg邱ƂłA
		̍ۂɂǂ̂炢XeBbN|炻̕ւ̓͂ƌȂAݒł܂B
		1͉A2͏ĉlw肵܂Bl͈̔͂0`1000łBl500ɂȂĂ܂B
	*/
	void			setBorder(int borderX, int borderY);

	//!	XeBbN̍ŏEől̐ݒ
	/*
		XeBbNԂl͔Ƀu邽߁AĂȂĂ҂0ɂȂȂA
		ڈt|Ă1000ɂȂȂ肵܂B
		̂߁Al0ƌȂAl傫1000ƌȂƂݒ肪ł܂B
		l΂Jbg邾ł͂ȂAL͈͂ƂȂl0`1000͈̔͂Ƀ}bsO܂̂ŁA
		Q[̏͏0`1000͈̔͂ŏlĂΌ\łB
		1ɍŏlA2ɍőlw肵܂Bl͈̔͂0`1000łAŏlől傫悤
		wꍇ̓G[ɂȂ̂ŁAݒύXɖ܂Bl͍ŏl200Aől900łB
	*/
	void			setMinMax(int min, int max);

	//!	{^̓ւݒ
	/*
		{^̔ԍւ邱Ƃł܂B
		1ɃWCXeBbNIDԍA2ɃQ[ł̃{^ԍA3Ƀpbh̐̃{^ԍw肵܂B
		l̓{^̐̔ԍ̂܂܂ΉÂĂ܂BQ[ł̃{^̂񋓌^ŖOtāA
		Ήt̂߂łBɂĔԍ0X^[gȂ̂ŒӂĂB
	*/
	void			setButtonSwap(int joyIndex, int id, int raw);

	//!	{^ɑ΂L[{[h̃ATC
	/*
		WCXeBbÑ{^̑ɎgpL[ݒ肵܂B
		1̓Q[ł̃{^ԍA2ɃL[R[hw肵܂B
		Q[ł̃{^ԍƂ́AsetButtonSwap()Őݒ肵uւ̔ԍvw܂B

		L[R[h̎ẃAdinput.hŒ`ĂuDIK_vŎn܂萔gčs܂B
		L[{[hł֑̑̓WCXeBbNID0̂̂ɑ΂Ă̂ݗLłB
	*/
	void			setKeyAssign(int id, DWORD keycode);

	//!	XeBbNɑ΂L[{[h̃ATC
	/*
		WCXeBbÑXeBbN̑ɎgpL[ݒ肵܂B
		10ōXeBbN(ʏ\L[ƂĎg)A1ŉEXeBbN\܂B
		2ȍ~͏ԂɁA㉺EɑΉL[R[hw肵܂B

		L[R[h̎ẃAdinput.hŒ`ĂuDIK_vŎn܂萔gčs܂B
		L[{[hł֑̑̓WCXeBbNID0̂̂ɑ΂Ă̂ݗLłB
	*/
	void			setAxisAssign(int axis_id, DWORD up, DWORD dn, DWORD lt, DWORD rt);

	//!	POV{^ɑ΂L[{[h̃ATC
	/*
		WCXeBbNPOV{^̑ɎgpL[ݒ肵܂B
		1珇ԂɁAA^AEAAEAA^AEɑΉL[R[hw肵܂B

		L[R[h̎ẃAdinput.hŒ`ĂuDIK_vŎn܂萔gčs܂B
		L[{[hł֑̑̓WCXeBbNID0̂̂ɑ΂Ă̂ݗLłB
	*/
	void			setPOVAssign(DWORD ul, DWORD u, DWORD ur, DWORD l, DWORD r, DWORD dl, DWORD d, DWORD dr);

	//!	L[{[h܂߂͏Ԏ擾
	/*
		͏Ԃ擾܂Bfkut_InputInfo^̕ϐ炩ߗpӂAŎ󂯎ĂB
		ɂ̓WCXeBbNIDw肵܂A0w肵ꍇ̓WCXeBbNڑĂȂꍇA
		L[{[h̓͂fꂽ񂪕ԂĂ܂BڑĂꍇ̓WCXeBbN̏ԂԂ܂B

	*/
	fkut_InputInfo	getInputStatus(int = 0);

};
